{-# LANGUAGE OverloadedStrings #-}

module ISTEX where

import ISTEX.Client
import Network.HTTP.Client (newManager)
import Network.HTTP.Client.TLS (tlsManagerSettings)
import Servant.Client

import qualified Data.Text as T

runIstexAPIClient :: ClientM (Documents) -> IO (Either ClientError Documents)
runIstexAPIClient cmd = do
  manager' <- newManager tlsManagerSettings
  runClientM cmd (mkClientEnv manager' $ BaseUrl Https "api.istex.fr" 443 "document")

basicSearch :: Maybe T.Text -> IO (Either ClientError Documents)
basicSearch rq = do
  runIstexAPIClient $
    search
    (Just "author,title,abstract,publicationDate")
    (Just 5)
    rq
